/*
 * Newt-Puzzle
 * Copyright (C) Aude Jaulent 2008, 2009 <elderme@tuxfamily.org>
 * 
 * Newt-Puzzle is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Newt-Puzzle is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _GLUTIL_H_
#define _GLUTIL_H_

#ifdef WIN32
	#include <windows.h>
#endif

#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glext.h>

#include <vector>
#include <iostream>
#include <math.h>
#include <string>

//#define GL_GLEXT_PROTOTYPES 1 // ??
#define pi 3.1415927 
 

extern bool VBOsupported;
extern bool GLSLsupported;
extern bool FBOsupported;


bool isExtensionAvailable(char *extensionName);
void printGLInfos();
void printGLSLInfos();


void printGLError();


int setAnisotropicFiltering(int nbAnisotropy);

int getMaxLights();
int getMaxTextureUnits();
int getTextureSizeMax();

int processHits(GLint hits, GLuint buffer[]);
std::vector<int> processHitsList(int nbObjects, GLint hits, GLuint buffer[]);
  
#endif // _GLUTIL_H_
